<?php
// ----------------------------------------------------------------------
// Fast Click - Clicks Counter System
// Copyright (c) 2001 by Dmitry Ignatyev (ftrain@mail.ru)
// http://www.ftrain.h1.ru/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Dmitry Ignatyev
// ----------------------------------------------------------------------

include("cfg.php");

if(file_exists("language/$language.php"))
 include("language/$language.php");
else
 @include("language/english.php");

$version = "v2.1";

// HTML Header

function head() {
?>
<html>
<head>
 <title>Fast Click</title>
 <meta http-equiv="Content-type" content="text/html; charset=<?=_CHARSET?>">
 <link href="style.css" type="text/css" rel="stylesheet">
</head>
<body bgcolor="#FFFFFF">
<?php
}

// HTML Foot

function foot() {
global $version;
echo "<br><div align=center><a href=\"http://www.ftrain.h1.ru\">FastClick</a> $version</div>\n";
echo "<div align=center>Copyright &copy;2001 by Trainer</div>\n";
echo "</body></html>";
}

// Administrator Login

function login() {
 global $pass, $sPassword;

 if($pass == $sPassword) Header("Location: admin.php?pass=$pass");
 else if(isset($pass))
  {
   $warning = "<br><font color=#ff0000>_WRONGPASS</font>";
  }
 head();
?>
<TABLE cellpadding="4" cellspacing="4" border="0" width="250" align="center">
 <TR>
  <TD>
   <TABLE bgcolor="#000000" cellpadding="0" cellspacing="1" border="0" width="100%">
    <TR>
     <TD>
      <TABLE bgcolor="#FFFFFF" cellpadding="0" cellspacing="0" border="0" width="100%">
       <TR>
        <TD>
         <TABLE cellpadding="2" cellspacing="1" border="0" width="100%" class="text">
          <form action="admin.php" method=post>
          <TR><TD bgcolor="#a5bcc0" align="center" style="font-size:11pt;"><?=_ADMINLOGIN?></TD></TR>
          <TR>
           <TD bgcolor="#e9e9e9" align="center">
            <?=$warning?>
            <p class="form"><?=_PASSWORD?>:<br><input type="password" name="pass" value="" class="field"></p>
            <input type="submit" value="Login" class="button"><br><br>
           </TD>
          </TR>
          </form>
         </TABLE>
        </TD>
       </TR>
      </TABLE>
     </TD>
    </TR>
   </TABLE>
  </TD>
 </TR>
</TABLE>
<?php
 foot();
}

// Click Statistic

function show() {
 global $datafile, $dayfile, $pass;
 head();

 $today=(int)(time()/86400);

 $base=@file($datafile); $cnt=count($base);
 $last_date=date("d F Y H:i",$base[0]);
 $num = $cnt-1;
 $all=0; $today_all=0; $last_all=0; $last7_all=0;
 for($i=1;$i<$cnt;$i++) {
   list($id,$count,$url,$name)=explode("|", $base[$i]);
   $id_b[$i-1] = $id;
   $total_b[$id] = $count;
   $url_b[$id] = $url;
   $name_b[$id] = $name;
   $all+=$count;
  }

 $day_base=@file($dayfile); $cnt=count($day_base);
 for($i=0;$i<$cnt;$i++) {
   list($day,$id,$count)=explode("|", $day_base[$i]);
   if($day==$today) { $today_b[$id]+=$count; $today_all+=$count; }
   if($day==$today-1) { $last_b[$id]+=$count; $last_all+=$count; }
   $last7_b[$id]+=$count; $last7_all+=$count;
  }
?>
<DIV align="center" style="font-size:14pt; letter-spacing:2pt;"><B><?=_STATISTIC?></B></DIV>
<TABLE cellpadding="4" cellspacing="4" border="0" width="100%">
 <TR>
  <TD valign="top">
   <TABLE border="0" class="text" width="100%" cellpadding="2" cellspacing="1">
    <TR><TD bgcolor="#a5bcc0" align="center" style="font-size:9pt;"><B>.: <?=_MENU?> :.</B></TD></TR>
    <TR><TD align="center"><A href="admin.php?pass=<?=$pass?>"><B>.: <?=_STATISTIC?></B></A></TD></TR>
    <TR><TD align="center"><A href="admin.php?pass=<?=$pass?>&admin=config"><B>.: <?=_CONFIG?></B></A></TD></TR>
   </TABLE>
  </TD>
  <TD width="85%">
   <TABLE bgcolor="#000000" cellpadding="0" cellspacing="1" border="0" width="100%">
    <TR>
     <TD>
      <TABLE bgcolor="#FFFFFF" cellpadding="0" cellspacing="0" border="0" width="100%">
       <TR>
        <TD>
         <TABLE cellpadding="2" cellspacing="1" border="0" width="100%" class="text">
          <TR><TD bgcolor="#a5bcc0" align="center" colspan="5"><?=_CLICKSTAT?></TD></TR>
          <TR>
           <TD bgcolor="#c5dce0" align="center"><B><?=_LINK?></B></TD>
           <TD bgcolor="#c5dce0" align="center"><B><?=_TODAY?></B></TD>
           <TD bgcolor="#c5dce0" align="center"><B><?=_YESTERDAY?></B></TD>
           <TD bgcolor="#c5dce0" align="center"><B><?=_FORWEEK?></B></TD>
           <TD bgcolor="#c5dce0" align="center"><B><?=_TOTAL?></B></TD>
          </TR>
<?php
 for($i=0;$i<$num;$i++) {
   $id=$id_b[$i];
   if(!isset($today_b[$id])) $today_b[$id] = 0;
   if(!isset($last_b[$id])) $last_b[$id] = 0;
   if(!isset($last7_b[$id])) $last7_b[$id] = 0;
   $raz = $today_b[$id] - $last_b[$id];
   echo "          <TR>\n";
   echo "           <TD bgcolor=\"#e9e9e9\" align=center><a href=\"$url_b[$id]\">$name_b[$id]</a></TD>\n";
   echo "           <TD bgcolor=\"#e9e9e9\" align=center>$today_b[$id]";
   if($raz > 0) echo " <font color=\"#00aa00\">+$raz</font>";
   else if($raz < 0) echo " <font color=\"#ff0000\">$raz</font>";
   echo "</TD>\n";
   echo "           <TD bgcolor=\"#e9e9e9\" align=center>$last_b[$id]</TD>\n";
   echo "           <TD bgcolor=\"#e9e9e9\" align=center>$last7_b[$id]</TD>\n";
   echo "           <TD bgcolor=\"#e9e9e9\" align=center>$total_b[$id]</TD>\n";
   echo "          </TR>\n";
  }
 echo "          <TR>\n";
 echo "           <TD bgcolor=\"#c5dce0\" align=center><b><?=_TOTAL?></b></TD>\n";
 echo "           <TD bgcolor=\"#c5dce0\" align=center><b>$today_all</b></TD>\n";
 echo "           <TD bgcolor=\"#c5dce0\" align=center><b>$last_all</b></TD>\n";
 echo "           <TD bgcolor=\"#c5dce0\" align=center><b>$last7_all</b></TD>\n";
 echo "           <TD bgcolor=\"#c5dce0\" align=center><b>$all</b></TD>\n";
 echo "          </TR>\n";
 echo "          <TR><TD colspan=5 align=center><b>"._TOTALLINKS.": <font color=\"#556c70\">$num</font>\n";
 echo "           | "._LASTCLICK.": <font color=\"#556c70\">$last_date</font></b></TD></TR>\n";
?>
         </TABLE>
        </TD>
       </TR>
      </TABLE>
     </TD>
    </TR>
   </TABLE>
  </TD>
 </TR>
</TABLE>
<?php
 foot();
}


// Configure

function config() {
 global $datafile, $pass, $error_message;
 head();
?>
<script language="Javascript">
<!--
function check_char(strg) {
 var found = 0;
 for(char_pos=0; char_pos<strg.length; char_pos++) {
   if(strg.charAt(char_pos) == "|" || strg.charAt(char_pos) == "&" || strg.charAt(char_pos) == "=" || strg.charAt(char_pos) == '"' || strg.charAt(char_pos) == "'") {
     found = 1;
     break;
    }
  }
 return (found == 1) ? false : true;
}
function set_value(entry, old_value) {
 var new_value = window.prompt("<?=_CHCOUNTER?> '"+entry+"' <?=_TO?>:",old_value)
 var found = 0;
 if(new_value != "" && new_value != null) {
   for(char_pos=0; char_pos<new_value.length; char_pos++) {
     if(!(new_value.charAt(char_pos) >= '0' && new_value.charAt(char_pos) <= '9')) {
       found = 1;
      }
    }
   if (found == 1) {
     alert ("<?=_WRONGVALUE?> "+entry+"!");
    }
   else if (new_value == old_value) {
     alert ("<?=_CHNOTMADE?>!");
    }
   else {
     window.location.href = "admin.php?pass=<?=$pass?>&admin=change_count&ad="+entry+"&new="+new_value
    }
  }
}
function ChangeEntry(entry, old_name, feature) {
 var new_name = window.prompt("<?=_ENTER?> "+feature+" <?=_FOR?> "+entry+":",old_name)
 var found = 1;
 if(new_name != "" && new_name != null) {
   if(check_char(new_name)) {
     found = 0;
    }
   if (found == 1) {
     alert ("<?=_ERROR?>! "+feature+" <?=_FOR?> "+entry+" <?=_UNACCEPTCHARS?>!");
    }
   else if(new_name == old_name) {
     alert ("<?=_CHNOTMADE?>!");
    }
   else if(feature == "Name") {
     window.location.href = "admin.php?pass=<?=$pass?>&admin=change_name&ad="+entry+"&new="+new_name
    }
   else if(feature == "ID") {
     window.location.href = "admin.php?pass=<?=$pass?>&admin=change_id&ad="+entry+"&new="+new_name
    }
   else if(feature == "URL") {
     window.location.href = "admin.php?pass=<?=$pass?>&admin=change_url&ad="+entry+"&new="+new_name
    }
  }
}
function del_entry(entry) {
 if (window.confirm("<?=_CONFIRMDEL?>: "+entry)) {
    window.location.href = "admin.php?pass=<?=$pass?>&admin=del&ad="+entry
 }
}
function clear_entry(entry) {
 if (window.confirm("<?=_CONFIRMDELSTAT?>: "+entry)) {
    window.location.href = "admin.php?pass=<?=$pass?>&admin=clear&ad="+entry
 }
}
function check_form() {
 var found = 1;
 name_field=document.form.add_name.value;
 id_field=document.form.add_id.value;
 if (name_field == "" || id_field == "") {
    alert ("<?=_PLEASEFILL?>");
    return false;
 }
 if (check_char(name_field) && check_char(id_field)) {
    found = 0;
 }
 if (found == 1) {
    alert ("<?=_ERROR?>! <?=_FOUNDUNACCEPTCHARS?>!");
    return false;
 }
}
// -->
</script>
<DIV align="center" style="font-size:14pt; letter-spacing:2pt;"><B><?=_CONTROLPANEL?></B></DIV>
<TABLE cellpadding="4" cellspacing="4" border="0" width="100%">
 <TR>
  <TD valign="top">
   <TABLE border="0" class="text" width="100%" cellpadding="2" cellspacing="1">
    <TR><TD bgcolor="#a5bcc0" align="center" style="font-size:9pt;"><B>.: <?=_MENU?> :.</B></TD></TR>
    <TR><TD align="center"><A href="admin.php?pass=<?=$pass?>"><B>.: <?=_STATISTIC?></B></A></TD></TR>
    <TR><TD align="center"><A href="admin.php?pass=<?=$pass?>&admin=config"><B>.: <?=_CONFIG?></B></A></TD></TR>
   </TABLE>
  </TD>
  <TD width="85%">
   <TABLE bgcolor="#000000" cellpadding="0" cellspacing="1" border="0" width="100%">
    <TR>
     <TD>
      <TABLE bgcolor="#FFFFFF" cellpadding="0" cellspacing="0" border="0" width="100%">
       <TR>
        <TD>
         <TABLE cellpadding="2" cellspacing="1" border="0" width="100%" class="text">
          <TR><TD bgcolor="#a5bcc0" align="center" colspan="5"><?=_LINKSLIST?></TD></TR>
          <TR>
           <TD bgcolor="#c5dce0" align="center"><B><?=_ID?></B></TD>
           <TD bgcolor="#c5dce0" align="center"><B><?=_NAME?></B></TD>
           <TD bgcolor="#c5dce0" align="center"><B><?=_URL?></B></TD>
           <TD bgcolor="#c5dce0" align="center"><B><?=_CLICKS?></B></TD>
           <TD bgcolor="#c5dce0" align="center"><B><?=_ACTIONS?></B></TD>
          </TR>
<?php
 $base=@file($datafile); $cnt=count($base)-1;
 for($i=1;$i<=$cnt;$i++) {
   list($id,$count,$url,$name)=explode("|", $base[$i]);
   echo "          <TR>\n";
   echo "           <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:ChangeEntry('$id', '$id', 'ID')\" class=opt>$id</a></TD>\n";
   echo "           <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:ChangeEntry('$id', '$name', 'Name')\" class=opt>$name</a></TD>\n";
   echo "           <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:ChangeEntry('$id', '$url', 'URL')\"\n";
   echo "            class=opt>$url</a></TD>\n";
   echo "           <TD bgcolor=\"#e9e9e9\" align=center><a href=\"javascript:set_value('$id', '$count')\" class=opt>$count</a></TD>\n";
   echo "           <TD bgcolor=\"#e9e9e9\" align=center width=140><a href=\"javascript:del_entry('$id');\" class=opt>"._DELETE."</a>\n";
   echo "             : <a href=\"javascript:clear_entry('$id');\" class=opt>"._CLEAR."</a></TD>\n";
   echo "          </TR>\n";
  }
 echo "          <TR><TD colspan=5 align=center bgcolor=\"#c5dce0\"><b>"._TOTALLINKS.": <font color=\"#556c70\">$cnt</font></b></TD></TR>\n";
?>
         </TABLE>
        </TD>
       </TR>
      </TABLE>
     </TD>
    </TR>
   </TABLE>
  </TD>
 </TR>
</TABLE>
<table align="center" border=0 class=text cellpadding=1 cellspacing=1>
 <form action="admin.php" method="post" name="form">
<?php
 if(isset($error_message)) {
?>
  <tr>
   <td align="center" colspan=2>
    <font color="#ff0000"><b><?=_ERROR?>: <?=$error_message?></b></font><br><br>
   </td>
  </tr>
<?php } ?>
 <tr>
  <td align="center" colspan=2 bgcolor="#a5bcc0">
   <font style="letter-spacing : 3px;"><?=_ADDLINK?>:</font>
  </td>
 </tr>
 <tr>
  <td align="right" bgcolor="#e9e9e9"><?=_ID?>: </td>
  <td bgcolor="#e9e9e9"><input type="text" name="add_id" class=field style="width: 150pt;"></td>
 </tr>
 <tr>
  <td align="right" bgcolor="#e9e9e9"><?=_NAME?>: </td>
  <td bgcolor="#e9e9e9"><input type="text" name="add_name" class=field style="width: 150pt;"></td>
 </tr>
 <tr>
  <td align="right" bgcolor="#e9e9e9"><?=_URL?>: </td>
  <td bgcolor="#e9e9e9"><input type="text" name="add_url" value="http://" class="field" style="width: 150pt;"></td>
 </tr>
 <tr>
  <td align="right" colspan=2 bgcolor="#e9e9e9">
   <input type="hidden" name="pass" value="<?=$pass?>">
   <input type="hidden" name="admin" value="add_link">
   <input type="submit" value="<?=_ADDOBJECT?>" class=button style="width: 150pt;" onclick="return check_form();">
  </td>
 </tr>
 </form>
</table>
<?php
 foot();
}

// Clean of statistic

function clear($flag=1) {
global $datafile, $ad, $dayfile;

if($flag) {
  $base=@file($datafile); $cnt=count($base);
  for($i=1;$i<$cnt;$i++) {
    list($id,$count,$url,$name)=explode("|", $base[$i]);
    if($id==$ad) {
      $base[$i]="$id|0|$url|$name|\n";
      $f=fopen($datafile, "w");
      $str=implode($base,"");
      fwrite($f, $str);
      fclose($f);
      break;
     }
   }
 }

$daylog=@file($dayfile); $cnt=count($daylog);
$found = 0;
for($i=0;$i<$cnt;$i++) {
  list($day,$id,$count)=explode("|", $daylog[$i]);
  if($ad == $id) {
    $found = 1;
    $daylog[$i]="";
   }
 }

if($found) {
  $f=fopen($dayfile, "w");
  $str=implode($daylog,"");
  fwrite($f, $str);
  fclose($f);
 }
}

// Actions above recordings

function action() {
global $datafile, $admin, $ad, $new;

$base=file($datafile); $cnt=count($base);
for($i=1;$i<$cnt;$i++) {
  list($id,$count,$url,$name)=explode("|", $base[$i]);
  if($id==$ad) {
    if($admin == "del") { $base[$i]=""; clear(0); }
    else if($admin == "change_id") {
      $new = str_replace(" ", "", $new);
      $base[$i]="$new|$count|$url|$name|\n";
     }
    else if($admin == "change_count")
     $base[$i]="$id|$new|$url|$name|\n";
    else if($admin == "change_url")
     $base[$i]="$id|$count|$new|$name|\n";
    else if($admin == "change_name")
     $base[$i]="$id|$count|$url|$new|\n";
    $f=fopen($datafile, "w");
    $str=implode($base,"");
    fwrite($f, $str);
    fclose($f);
    break;
   }
 }
}

// Add ULR

function add_link() {
 global $add_id, $add_name, $add_url, $datafile, $error_message;

 $base=@file($datafile); $cnt=count($base);
 $add_id = str_replace(" ", "", $add_id);

 for($i=1;$i<=$cnt;$i++) {
   list($id,$count,$url,$name)=explode("|", $base[$i]);
   if($id == $add_id) $found = 1;
  }
 if(!$found)
  {
   if(!file_exists($datafile)) $add_str = time()."\n";
   $add_str.="$add_id|0|$add_url|$add_name|\n";
   $f=fopen($datafile, "a");
   fwrite($f, $add_str);
   fclose($f);
  }
 else $error_message = _IDEXISTS;
}

// Main

if($pass != $sPassword) { login(); }
else if($admin == "config") { config(); }
else if($admin == "clear") { clear(); config(); }
else if($admin == "add_link") { add_link(); config(); }
else if(isset($admin)) { action(); config(); }
else { show(); }
?>